Flate::Reader -

# class Flate::Reader

- Flate::Reader
- IO
- Reference
- Object

## Overview

A read-only `IO` object to decompress data in the DEFLATE format.

Instances of this class wrap another IO object. When you read from this instance instance, it reads data from the underlying IO, decompresses it, and returns it to the caller.

## Included Modules

- IO::Buffered

## Defined in:

## Constructors

- .gzip(input, sync_close : Bool = false) : self

  Creates an instance of Flate::Reader for the gzip format.

- .new(io : IO, sync_close : Bool = false, dict : Bytes? = nil)

  Creates an instance of Flate::Reader.

## Class Method Summary

- .gzip(input, sync_close : Bool = false, &block)

  Creates an instance of Flate::Reader for the gzip format, yields it to the given block, and closes it at its end.

- .open(io : IO, sync_close : Bool = false, dict : Bytes? = nil, &block)

  Creates a new reader from the given io, yields it to the given block, and closes it at its end.

## Instance Method Summary

- #closed? : Bool

  Returns `true` if this reader is closed.

- #dict : Bytes?

  Dictionary passed in the constructor

- #sync_close=(sync_close : Bool)

  If `#sync_close?` is `true`, closing this IO will close the underlying IO.

- #sync_close? : Bool

  If `#sync_close?` is `true`, closing this IO will close the underlying IO.

- #unbuffered_close

  Closes this reader.

- #unbuffered_flush
- #unbuffered_read(slice : Bytes)

  See `IO#read`.

- #unbuffered_rewind
- #unbuffered_write(slice : Bytes)

  Always raises `IO::Error` because this is a read-only `IO`.

### Instance methods inherited from module `IO::Buffered`

buffer_size buffer_size, buffer_size=(value) buffer_size=, close : Nil close, flush flush, peek : Bytes? peek, read(slice : Bytes) read, read_buffering=(read_buffering) read_buffering=, read_buffering? read_buffering?, rewind rewind, sync=(sync) sync=, sync? sync?, unbuffered_close unbuffered_close, unbuffered_flush unbuffered_flush, unbuffered_read(slice : Bytes) unbuffered_read, unbuffered_rewind unbuffered_rewind, unbuffered_write(slice : Bytes) unbuffered_write, write(slice : Bytes) : Nil write

### Instance methods inherited from class `IO`

<<(obj) : self <<, close close, closed? closed?, each_byte(&block) : Nil
each_byte each_byte, each_char(&block) : Nil
each_char each_char, each_line(*args, **options, &block : String -> ) : Nil
each_line(*args, **options) each_line, encoding : String encoding, flush flush, gets(delimiter : Char, limit : Int, chomp = false) : String?
gets(delimiter : Char, chomp = false) : String?
gets(chomp = true) : String?
gets(limit : Int, chomp = false) : String?
gets(delimiter : String, chomp = false) : String? gets, gets_to_end : String gets_to_end, peek : Bytes? peek, pos pos, pos=(value) pos=, print(*objects : UNDERSCORE) : Nil
print(obj) : Nil print, printf(format_string, *args) : Nil
printf(format_string, args : Array | Tuple) : Nil printf, puts(*objects : UNDERSCORE) : Nil
puts : Nil
puts(obj) : Nil
puts(string : String) : Nil puts, read(slice : Bytes) read, read_at(offset, bytesize, &block) read_at, read_byte : UInt8? read_byte, read_bytes(type, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) read_bytes, read_char : Char? read_char, read_fully(slice : Bytes) read_fully, read_fully?(slice : Bytes) read_fully?, read_line(*args, **options) : String read_line, read_string(bytesize : Int) : String read_string, read_utf8(slice : Bytes) read_utf8, read_utf8_byte read_utf8_byte, rewind rewind, seek(offset, whence : Seek = Seek::Set) seek, set_encoding(encoding : String, invalid : Symbol? = nil) set_encoding, skip(bytes_count : Int) : Nil skip, skip_to_end : Nil skip_to_end, tell tell, tty? : Bool tty?, write(slice : Bytes) : Nil write, write_byte(byte : UInt8) write_byte, write_bytes(object, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) write_bytes, write_utf8(slice : Bytes) write_utf8

### Class methods inherited from class `IO`

copy(src, dst, limit : Int) : UInt64
copy(src, dst) : UInt64 copy, pipe(read_blocking = false, write_blocking = false) : Tuple(IO::FileDescriptor, IO::FileDescriptor)
pipe(read_blocking = false, write_blocking = false, &block) pipe

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO) : Nil
inspect : String inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Constructor Detail

def self.gzip(input, sync_close : Bool = false) : self #

Creates an instance of Flate::Reader for the gzip format. has written.

def self.new(io : IO, sync_close : Bool = false, dict : Bytes? = nil) #

Creates an instance of Flate::Reader.

## Class Method Detail

def self.gzip(input, sync_close : Bool = false, &block) #

Creates an instance of Flate::Reader for the gzip format, yields it to the given block, and closes it at its end.

def self.open(io : IO, sync_close : Bool = false, dict : Bytes? = nil, &block) #

Creates a new reader from the given io, yields it to the given block, and closes it at its end.

## Instance Method Detail

def closed? : Bool #

Returns `true` if this reader is closed.

def dict : Bytes? #

Dictionary passed in the constructor

def sync_close=(sync_close : Bool) #

If `#sync_close?` is `true`, closing this IO will close the underlying IO.

def sync_close? : Bool #

If `#sync_close?` is `true`, closing this IO will close the underlying IO.

def unbuffered_close #

Closes this reader.

def unbuffered_flush #
def unbuffered_read(slice : Bytes) #

See `IO#read`.

def unbuffered_rewind #
def unbuffered_write(slice : Bytes) #

Always raises `IO::Error` because this is a read-only `IO`.